
#include <extdll.h>			// always

#include <api_info.h>		// api_info_t, etc
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include "statsme.h"	// me
#include <ctype.h>

cvar_t	*statsme_version;
cvar_t	*sm_logformat;
cvar_t	*sm_sayformat;
cvar_t	*sm_headshot;
cvar_t	*sm_bombset;
cvar_t	*sm_bombtimefreq;
cvar_t	*sm_bombtimecont;
cvar_t	*sm_kill;
cvar_t	*sm_monsterkill;
cvar_t	*sm_monsterkillnum;
cvar_t	*sm_roundend;
cvar_t	*sm_roundenddelay;
cvar_t	*sm_logmenuaction;
//cvar_t	*sm_victimsdelay;
cvar_t	*sm_monsterfreq;
cvar_t	*sm_bombfreq;
cvar_t	*sm_bombcont;
cvar_t	*sm_playerstats;
cvar_t	*sm_weaponstats;
cvar_t	*sm_menupassword;
cvar_t	*sm_bombdefused;
cvar_t	*sm_bombfailure;
cvar_t	*sm_knifekill;
cvar_t	*sm_attackers;
cvar_t	*sm_victims;
cvar_t	*sm_killsforrank;
cvar_t	*sm_rankcmd;
cvar_t	*sm_statsmecmd;
cvar_t	*sm_statscmd;
cvar_t	*sm_resetrank;
cvar_t  *sm_latlogformat;
cvar_t  *sm_latlogfreq;
cvar_t  *sm_timelogformat;
cvar_t  *sm_switchcmd;
cvar_t  *sm_logformat2;
cvar_t	*sm_attackersbody;
cvar_t	*sm_victimsbody;
cvar_t	*sm_resetonrestart;
cvar_t	*mp_timelimit;

cvar_t	init_statsme_version		=	{"statsme_version",VVERSION, FCVAR_SERVER | FCVAR_SPONLY};
cvar_t	init_sm_attackersbody		=	{"sm_attackersbody",""};
cvar_t	init_sm_victimsbody			=	{"sm_victimsbody",""};
cvar_t	init_sm_playerstats			=   {"sm_playerstats",""};
cvar_t	init_sm_weaponstats			=   {"sm_weaponstats",""};
cvar_t	init_sm_logformat			=	{"sm_logformat","error: statsme.cfg not executed!"};
cvar_t	init_sm_logformat2			=	{"sm_logformat2","error: statsme.cfg not executed!"};
cvar_t	init_sm_sayformat			=	{"sm_sayformat","200=100=0=-1=0.20=0=0.5=12=2.00=0.5=1"};
cvar_t	init_sm_menupassword		=	{"sm_menupassword",""};
cvar_t	init_sm_headshot			=	{"sm_headshot",""};
cvar_t	init_sm_bombset				=	{"sm_bombset",""};
cvar_t	init_sm_bombtimefreq		=	{"sm_bombtimefreq",""};
cvar_t	init_sm_bombtimecont		=	{"sm_bombtimecont",""};
cvar_t	init_sm_kill				=	{"sm_kill",""};
cvar_t	init_sm_monsterkill			=   {"sm_monsterkill",""};
cvar_t	init_sm_monsterkillnum		=	{"sm_monsterkillnum","3",0,3};
cvar_t	init_sm_roundend			=	{"sm_roundend",""};
cvar_t	init_sm_monsterfreq			=   {"sm_monsterfreq","3",0,3};
cvar_t	init_sm_bombfreq			=	{"sm_bombfreq",""};
cvar_t	init_sm_bombcont			=	{"sm_bombcont",""};
cvar_t	init_sm_knifekill			=	{"sm_knifekill",""};
cvar_t	init_sm_bombdefused			=	{"sm_bombdefused",""};
cvar_t	init_sm_bombfailure			=	{"sm_bombfailure",""};
cvar_t	init_sm_attackers			=	{"sm_attackers",""};
cvar_t	init_sm_victims				=	{"sm_victims",""};
cvar_t	init_sm_killsforrank		=	{"sm_killsforrank","30",0,30};
cvar_t	init_sm_statsmecmd			=	{"sm_statsmecmd","/statsme"};
cvar_t	init_sm_statscmd			=	{"sm_statscmd","/stats"};
cvar_t	init_sm_rankcmd				=	{"sm_rankcmd","/top15"};
cvar_t	init_sm_resetrank			=	{"sm_resetrank","72",0,72};
cvar_t  init_sm_latlogformat		=	{"sm_latlogformat", "(ping \"{ping}\")"};
cvar_t  init_sm_latlogfreq			=	{"sm_latlogfreq","20",0,20};
cvar_t	init_sm_timelogformat		=	{"sm_timelogformat","(time \"{time}\")"};
cvar_t	init_sm_switchcmd			=	{"sm_switchcmd","/switch"};
cvar_t	init_sm_resetonrestart		=	{"sm_resetonrestart","1",0,1};
cvar_t	init_sm_roundenddelay		=	{"sm_roundenddelay","5",0,5};
cvar_t	init_sm_logmenuaction		=	{"sm_logmenuaction","1",0,1};
//cvar_t	init_sm_victimsdelay		=	{"sm_victimsdelay","5",0,5};

int ReadFlags(char* c)
{
	int parm = atoi(c);
	if (!parm && *c){ //this is in alphabetic format (i.e. "abe")
		while (*c)	{ if (isalpha(*c)) {*c = tolower(*c); parm |= (1<<((*c)-'a'));} c++; };
	}
	
	return parm;
}


void register_funcall(void) {

	if (CMD_ARGC() > 3)
	{
		int arg_num = CMD_ARGC();
		int pos = atoi(CMD_ARGV(1));
		if (!pos){ //if this was not numer but name then check again
			pos = GET_USER_MSG_ID(PLID, CMD_ARGV(1) , NULL );
		}
		int len = strlen(CMD_ARGV(2));
		if (pos&&len) {
			fun_call_t* new_object = new fun_call_t;
			new_object->cmd = new char[len+1];
			strcpy(new_object->cmd,CMD_ARGV(2));
			new_object->len = len;
			new_object->where = 63 - len;
			new_object->done = false;
			new_object->cond = NULL;
			new_object->next = NULL;
			new_object->stamp = 0.0;
			int parm = ReadFlags((char*)CMD_ARGV(3));
			new_object->world=(parm&1)?true:false;
			new_object->player=(parm&2)?true:false;
			new_object->once=(parm&4)?true:false; //do only once
			new_object->quotes=(parm&8)?0:1; //don't use quotes
			new_object->fillme=(parm&16)?true:false; //fill with extra info
			if (arg_num > 4){
				for(int i = 4; i < arg_num; ++i){	//add conditions (i.e. "2=#Terrorist_Wins")	
					char* cond = (char*)CMD_ARGV(i);
					cond[1] = '\0';
					int pos_val = cond[0] - '0'; /// "2=..." - we can only accept cond from 1 to 9
					if (pos_val){
						cond_t* new_one = new cond_t;
						cond = cond + 2;
						int len_me = strlen(cond);
						new_one->toval = new char[len_me+1];
						strcpy(new_one->toval,cond);
						new_one->tovallen = len_me;
						new_one->val = pos_val;
						new_one->next = NULL;
						if (new_object->cond){
							cond_t*nstr = new_object->cond;
							while(nstr&&nstr->next)	nstr = nstr->next;
							nstr->next = new_one;
						}
						else {
							new_object->cond = new_one;
						}
					}
				}
			}
			if (modMsgFunCalls[pos]) {
				fun_call_t* start = modMsgFunCalls[pos];
				new_object->quotes = start->quotes; //force new object to use format as first registered cmd
				while (start && start->next) start = start->next;
				start->next = new_object;
			}
			else {					
				modMsgFunCalls[pos] = new_object;
			}
		}
	}
	else {
		SERVER_PRINT("Usage:   sm_register < msg_type > < command > < switches > < optional conditions >\n");
	}
}

void CmdSetMode(void){

	if (CMD_ARGC() > 2)	{

		int value = ReadFlags((char*)CMD_ARGV(2));

		if (!strcmpi(CMD_ARGV(1),"set"))
		{
			score.sm_mode |= value;

		}
		else if (!strcmpi(CMD_ARGV(1),"remove"))
		{
			score.sm_mode &= ~value;
		}
		else 
		{
			SERVER_PRINT("Usage:   sm_mode < set | remove > < bits >\n");
		}
	}
	else 
	{
		SERVER_PRINT("Usage:   sm_mode < set | remove > < bits >\n");
	}

}

bool IsANumber(const char * value)
{
	int length =0 ;

	while (value && *value)
	{
		if ( (!isdigit(*value)  && *value != '.') || (length > 18))
			return false;

		value++;
		length++;
	}
	
	return true;
}

void CmdUseVar(void){

	if (CMD_ARGC() > 3)	{
		const char* var = LOCALINFO((char*)CMD_ARGV(1));
		int operation = *CMD_ARGV(2);
		const char* value = CMD_ARGV(3);
		float fvar = atof(var);
		float newvar = fvar;
		
		switch(operation)
		{
		case '|':{
			int temp = fvar;
			newvar = ( temp |= atoi(value) );
				 }
			break;
		case '&':{
			int temp = fvar;
			newvar = ( temp &= ~atoi(value) );
				 }
			break;
		case '+':
			newvar = ( fvar + atof(value) );
			break;
		case '-':
			newvar = ( fvar - atof(value) );
			break;
		case '*':
			newvar = ( fvar * atof(value) );
			break;
		case '/':
			newvar = ( fvar / atof(value) );
			break;
		case '%':
			newvar = ( (int)fvar % atoi(value) );
			break;
		case '=':
			newvar = atof(value);
			break;
		}
		SET_LOCALINFO((char*)CMD_ARGV(1),UTIL_VarArgs("%f",newvar));
	}
	else
	{
		SERVER_PRINT("Usage:   sm_var < localinfo > < operator > < value >\n");
	}

}

void TASK_COMMAND(char* cmd, float time, int flags)
{
	task_t*new_one=new task_t;
	new_one->cmd = new char[strlen(cmd)+1];
	strcpy(new_one->cmd,cmd);
	new_one->repeat = (flags&1)?time:0;
	new_one->flags = flags;
	new_one->time = time;
	new_one->next = NULL;
	if (sm_task){
		task_t*start = sm_task;
		while (start->next)
			start = start->next;
		start->next = new_one;
	}
	else {
		sm_task = new_one;
	}
}

void CmdTask(void) 
{
	if (CMD_ARGC() > 2) {

		int flags = ReadFlags((char*)CMD_ARGV(3));
		
		char* todo = (flags&2) ? UTIL_FillWithVars(CMD_ARGV(2)) : (char*)CMD_ARGV(2);

		if (todo && *todo) TASK_COMMAND(todo , atof(CMD_ARGV(1)) , flags );

	}
	else {
		SERVER_PRINT("Usage:  sm_task < time in sec. > < server command > < flags >\n");
	}

}

void CmdDo(void) 
{
	if (CMD_ARGC() > 1) {
		char* args = (char*)CMD_ARGS();

		if (*args == '\"') {
			args = &args[1];
			int len = strlen(args)-1;
			if (args[len]=='\"')
				args[len] = '\0';
		}

		char* todo = UTIL_FillWithVars(args);
		if (todo && *todo) SERVER_COMMAND(todo);
	}
	else {
		SERVER_PRINT("Usage:  sm_do < server command >\n");
	}

}

void CmdAlias(void) 
{
	if (CMD_ARGC() > 3) {

		action_t*new_one=new action_t;

		new_one->name = new char[strlen(CMD_ARGV(1))+1];
		new_one->cmd = new char[strlen(CMD_ARGV(2))+1];

		int parm = ReadFlags((char*)CMD_ARGV(3));

		strcpy(new_one->name,CMD_ARGV(1));
		strcpy(new_one->cmd,CMD_ARGV(2));
		new_one->flags = parm;
		new_one->next = NULL;

		if (sm_alias){
			action_t*start = sm_alias;
			while (start->next)
				start = start->next;
			start->next = new_one;
		}
		else {
			sm_alias = new_one;
		}
	}
	else {
		SERVER_PRINT("Usage:  sm_alias < command > < server command > < flags >\n");
	}
}

void CmdMenu(void) 
{
	if (CMD_ARGC() > 2) {

		action_t*new_one=new action_t;

		new_one->name = new char[strlen(CMD_ARGV(1))+1];
		new_one->cmd = new char[strlen(CMD_ARGV(2))+1];

		strcpy(new_one->name,CMD_ARGV(1));
		strcpy(new_one->cmd,CMD_ARGV(2));

		new_one->next = NULL;

		if (sm_menu){
			action_t*start = sm_menu;
			while (start->next)
				start = start->next;
			start->next = new_one;
		}
		else {
			sm_menu = new_one;
		}
	}
	else {
		SERVER_PRINT("Usage:  sm_menu < description > < server command >\n");
	}
}

// Plugin startup.  Register commands and cvars.
void statsme_init(void) {
	LOG_MESSAGE(PLID, "%s %s, %s", Plugin_info.name, Plugin_info.version, Plugin_info.date);
	LOG_MESSAGE(PLID, "by %s", Plugin_info.author);
	LOG_MESSAGE(PLID, "   http://%s/", Plugin_info.url);
	LOG_MESSAGE(PLID, "compiled: %s", __DATE__ ", " __TIME__);

	REG_SVR_COMMAND ("sm_say", CmdSay);
	REG_SVR_COMMAND ("sm_clexec", CmdClExec);
	REG_SVR_COMMAND ("sm_motd", CmdMotd);
	REG_SVR_COMMAND ("sm_tell", CmdTell);
	REG_SVR_COMMAND ("sm_register", register_funcall);
	REG_SVR_COMMAND ("sm_mode", CmdSetMode);
	REG_SVR_COMMAND ("sm_menu", CmdMenu);
	REG_SVR_COMMAND ("sm_log", CmdLog);
	REG_SVR_COMMAND ("sm_alias", CmdAlias);
	REG_SVR_COMMAND ("sm_task", CmdTask);
	REG_SVR_COMMAND ("sm_showmenu", CmdShowMenu);
	REG_SVR_COMMAND ("sm_var", CmdUseVar);
	REG_SVR_COMMAND ("sm_do", CmdDo);	

	CVAR_REGISTER (&init_statsme_version);
	CVAR_REGISTER (&init_sm_timelogformat);
	CVAR_REGISTER (&init_sm_rankcmd);
	CVAR_REGISTER (&init_sm_statsmecmd);
	CVAR_REGISTER (&init_sm_statscmd);
	CVAR_REGISTER (&init_sm_logformat);
	CVAR_REGISTER (&init_sm_sayformat);
	CVAR_REGISTER (&init_sm_roundend);
	CVAR_REGISTER (&init_sm_monsterkill);
	CVAR_REGISTER (&init_sm_monsterkillnum);
	CVAR_REGISTER (&init_sm_kill);
	CVAR_REGISTER (&init_sm_bombtimefreq);
	CVAR_REGISTER (&init_sm_bombtimecont);
	CVAR_REGISTER (&init_sm_bombset);
	CVAR_REGISTER (&init_sm_headshot);
	CVAR_REGISTER (&init_sm_monsterfreq);
	CVAR_REGISTER (&init_sm_bombfreq);
	CVAR_REGISTER (&init_sm_bombcont);
	CVAR_REGISTER (&init_sm_playerstats);
	CVAR_REGISTER (&init_sm_weaponstats);
	CVAR_REGISTER (&init_sm_menupassword);
	CVAR_REGISTER (&init_sm_bombdefused);
	CVAR_REGISTER (&init_sm_bombfailure);
	CVAR_REGISTER (&init_sm_knifekill);
	CVAR_REGISTER (&init_sm_attackers);
	CVAR_REGISTER (&init_sm_victims);
	CVAR_REGISTER (&init_sm_killsforrank);
	CVAR_REGISTER (&init_sm_resetrank);
	CVAR_REGISTER (&init_sm_latlogformat);
	CVAR_REGISTER (&init_sm_latlogfreq);
	CVAR_REGISTER (&init_sm_switchcmd);
	CVAR_REGISTER (&init_sm_logformat2);
	CVAR_REGISTER (&init_sm_attackersbody);
	CVAR_REGISTER (&init_sm_victimsbody);
	CVAR_REGISTER (&init_sm_resetonrestart);
	CVAR_REGISTER (&init_sm_roundenddelay);
	CVAR_REGISTER (&init_sm_logmenuaction);
//	CVAR_REGISTER (&init_sm_victimsdelay);

	statsme_version=CVAR_GET_POINTER("statsme_version");
	sm_roundenddelay=CVAR_GET_POINTER("sm_roundenddelay");
	sm_logmenuaction=CVAR_GET_POINTER("sm_logmenuaction");
//	sm_victimsdelay=CVAR_GET_POINTER("sm_victimsdelay");
	sm_resetonrestart=CVAR_GET_POINTER("sm_resetonrestart");
	sm_attackersbody=CVAR_GET_POINTER("sm_attackersbody");
	sm_victimsbody=CVAR_GET_POINTER("sm_victimsbody");
	sm_switchcmd=CVAR_GET_POINTER("sm_switchcmd");
	sm_logformat2=CVAR_GET_POINTER("sm_logformat2");
	sm_timelogformat=CVAR_GET_POINTER("sm_timelogformat");
	sm_resetrank=CVAR_GET_POINTER("sm_resetrank");
	sm_rankcmd=CVAR_GET_POINTER("sm_rankcmd");
	sm_statsmecmd=CVAR_GET_POINTER("sm_statsmecmd");
	sm_statscmd=CVAR_GET_POINTER("sm_statscmd");
	sm_killsforrank=CVAR_GET_POINTER("sm_killsforrank");
	sm_attackers=CVAR_GET_POINTER("sm_attackers");
	sm_victims=CVAR_GET_POINTER("sm_victims");
	sm_knifekill=CVAR_GET_POINTER("sm_knifekill");
	sm_bombdefused=CVAR_GET_POINTER("sm_bombdefused");
	sm_bombfailure=CVAR_GET_POINTER("sm_bombfailure");
	sm_menupassword=CVAR_GET_POINTER("sm_menupassword");
	sm_playerstats=CVAR_GET_POINTER("sm_playerstats");
	sm_weaponstats=CVAR_GET_POINTER("sm_weaponstats");
	sm_logformat=CVAR_GET_POINTER("sm_logformat");
	sm_sayformat=CVAR_GET_POINTER("sm_sayformat");
	sm_headshot=CVAR_GET_POINTER("sm_headshot");
	sm_bombset=CVAR_GET_POINTER("sm_bombset");
	sm_bombtimefreq=CVAR_GET_POINTER("sm_bombtimefreq");
	sm_bombtimecont=CVAR_GET_POINTER("sm_bombtimecont");
	sm_kill=CVAR_GET_POINTER("sm_kill");
	sm_monsterkill=CVAR_GET_POINTER("sm_monsterkill");
	sm_monsterkillnum=CVAR_GET_POINTER("sm_monsterkillnum");
	sm_roundend=CVAR_GET_POINTER("sm_roundend");
	sm_bombfreq=CVAR_GET_POINTER("sm_bombfreq");
	sm_bombcont=CVAR_GET_POINTER("sm_bombcont");
	sm_monsterfreq=CVAR_GET_POINTER("sm_monsterfreq");
	sm_latlogformat=CVAR_GET_POINTER("sm_latlogformat");
	sm_latlogfreq=CVAR_GET_POINTER("sm_latlogfreq");

	memset(weapon_select,0,sizeof(weapon_select));
	memset(modMsgCmd,' ',sizeof(modMsgCmd));

	score.sm_mode = 0;
	score.mod_id = MOD_UNKNOW;

	time(&score.last_save); //save time when you are loading plugin (for ranks)

	// find out what MOD we are running
	char game_dir[256];
	GET_GAME_DIR(game_dir);
	int pos = strlen(game_dir) - 1;

	while (pos && game_dir[pos] != '/')
		--pos;// scan backwards till first directory separator...

	strcpy(score.mod_name, &game_dir[++pos]);

	struct mod_info_t {	char name[16];	short int id; } pSelect[] = {
		{"cstrike",MOD_CSTRIKE}, {"",MOD_UNKNOW} };

	int index = 0;

	while (pSelect[index].name[0] && strcmpi(score.mod_name, pSelect[index].name))
		++index;

	score.mod_id = pSelect[index].id; //save what mod we are running
}

char* UTIL_VarArgs( char *format, ... )
{
	va_list		argptr;
	static char		string[1024];
	
	va_start (argptr, format);
	vsprintf (string, format,argptr);
	va_end (argptr);

	return string;
}

void UTIL_LogPrintf( char *fmt, ... )
{
	va_list			argptr;
	static char		string[1024];
	
	va_start ( argptr, fmt );
	vsprintf ( string, fmt, argptr );
	va_end   ( argptr );

	ALERT( at_logged, "%s", string );
}

#define MAX_MOTD_CHUNK	  60
#define MAX_MOTD_LENGTH   1535

void UTIL_ShowMOTD( edict_t *client , char *pList, const char *szName)
{
	// send szName
	MESSAGE_BEGIN( MSG_ONE, gmsgServerName, NULL, client );
		WRITE_STRING(szName);
	MESSAGE_END();

	static char	chunk[MAX_MOTD_CHUNK+1];
	char	*aList = pList;
	int		ch_count = 0;

	while ( pList && *pList && ch_count < MAX_MOTD_LENGTH )
	{
		if ( strlen( pList ) < MAX_MOTD_CHUNK ) {
			strcpy( chunk, pList );
		}
		else {
			strncpy( chunk, pList, MAX_MOTD_CHUNK );
			chunk[MAX_MOTD_CHUNK] = 0;
		}

		ch_count += strlen( chunk );

		if ( ch_count < MAX_MOTD_LENGTH ) {
			pList = aList + ch_count; 
		}
		else {
			*pList = 0;
		}

		MESSAGE_BEGIN( MSG_ONE, gmsgMOTD, NULL, client );
			WRITE_BYTE( *pList ? FALSE : TRUE );// FALSE means there is still more message to come
			WRITE_STRING( chunk );
		MESSAGE_END();
	}

	// back server name
	MESSAGE_BEGIN( MSG_ONE, gmsgServerName, NULL, client );
		WRITE_STRING(CVAR_GET_STRING("hostname"));
	MESSAGE_END();
}

unsigned short FixedUnsigned16( float value, float scale ){
	int output;
	output = value * scale;
	if ( output < 0 )
		output = 0;
	if ( output > 0xFFFF )
		output = 0xFFFF;
	return (unsigned short)output;
}

short FixedSigned16( float value, float scale ){
	int output;
	output = value * scale;
	if ( output > 32767 )
		output = 32767;
	if ( output < -32768 )
		output = -32768;
	return (short)output;
}

void UTIL_HudMessage(const hudtextparms_t &textparms, char *pMessage, edict_t *pEntity)
{	
	if (pEntity){ // to specified player
		MESSAGE_BEGIN( MSG_ONE, SVC_TEMPENTITY, NULL, pEntity );
	}
	else { // to the public
		MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY, NULL);
	}

	WRITE_BYTE(29); 
	WRITE_BYTE(textparms.channel & 0xFF); 
	WRITE_SHORT(FixedSigned16(textparms.x, (1<<13) ));
	WRITE_SHORT(FixedSigned16(textparms.y, (1<<13) ));
	WRITE_BYTE(textparms.effect);
	WRITE_BYTE(textparms.r1);
	WRITE_BYTE(textparms.g1);
	WRITE_BYTE(textparms.b1);
	WRITE_BYTE(0);
	WRITE_BYTE(255);
	WRITE_BYTE(255);
	WRITE_BYTE(250);
	WRITE_BYTE(0);
	WRITE_SHORT(FixedUnsigned16(textparms.fadeinTime, (1<<8) ));
	WRITE_SHORT(FixedUnsigned16(textparms.fadeoutTime, (1<<8) ));
	WRITE_SHORT(FixedUnsigned16(textparms.holdTime, (1<<8) ));

	if ( textparms.effect == 2 )
		WRITE_SHORT(FixedUnsigned16(textparms.fxTime, (1<<8) ) );
	
	static char bMessage[256];
	int current = 0;		//Source position
	int len = 0;			//Over all length
	int line_len = 0;		//Line length
	int new_len = 0;		//Length from last space
	int last_space = -1;	//Place of last place

	//Go throw tekst and move to new line if needed
	while ( pMessage[len] && len < 254) {
		if (pMessage[len] == ' ' && len < 70) {
			last_space = len;	
			new_len = 0;
		}
		if (pMessage[len] == '\n') {
			line_len = 1; 
			last_space = -1;
		}

		bMessage[len++] = pMessage[current++];
		line_len++;	new_len++;

		if (line_len > 69) {
			if (last_space == -1) {
				bMessage[len++] = '\n';
				line_len = 0;
			}
			else {
				bMessage[last_space] = '\n';
				line_len = new_len;
			}
			last_space = -1;
		}
	}

	bMessage[len] = '\0';
	WRITE_STRING(bMessage);
	MESSAGE_END();
}

// used to check if argument specifing the player
bool CallsMe(player_t* pPlayer, const char* arg){
	
	if ( arg[0]=='*' && !arg[1] ) //check if wildcard
		return true;

	if ( arg[0]=='#' && atoi(arg+1) == GETPLAYERUSERID( pPlayer->pEdict ) ) //if user id is ok
		return true;
	
	if ( FStrEq( STRING( pPlayer->pEdict->v.netname ), arg ) )  //if name matches
		return true;
	
	if ( FStrEq( pPlayer->team_name , arg ) )  //or maybe team
		return true;

	if ( atoi(arg) == (int)GETPLAYERWONID( pPlayer->pEdict ) ) //and as last check for wonid
		return true;
	
	return false;
}

void CmdLog(void) 
{
	if (CMD_ARGC() > 1)	
	{
		UTIL_LogPrintf("%s\n", CMD_ARGS() );
	}
	else 
	{
		SERVER_PRINT("Usage:  sm_log < event >\n");
	}
}

void CmdSay(void)
{
	if (CMD_ARGC() > 1){
		float x=-1.0,y=0.25,fxTime=0.5,holdTime=12.0,fadeinTime=0.02,fadeoutTime=2.0;
		int effect=1, channel = 1, r=200,g=100,b=0;
		//if faild it will be "200=100=0=-1=0.20=0=0.5=12=0.02=2.0=1"
		sscanf (sm_sayformat->string,"%d%*1s%d%*1s%d%*1s%f%*1s%f%*1s%d%*1s%f%*1s%f%*1s%f%*1s%f%*1s%d",
			&r,&g,&b,&x,&y,&effect,&fxTime,&holdTime,&fadeinTime,&fadeoutTime, &channel);
		hudtextparms_t hudtextparm;hudtextparm.a1 = 0;hudtextparm.a2 = 0;
		hudtextparm.r2 = 255;hudtextparm.g2 = 255;hudtextparm.b2 = 250;
		hudtextparm.r1 = r;hudtextparm.g1 = g;hudtextparm.b1 = b;
		hudtextparm.effect = effect;hudtextparm.holdTime = holdTime;
		hudtextparm.fadeoutTime = fadeoutTime;hudtextparm.fadeinTime = fadeinTime;
		hudtextparm.x = x;hudtextparm.y = y;
		hudtextparm.fxTime = fxTime;hudtextparm.channel = channel;
		char* msg = (char*)CMD_ARGS();
		if (*msg == '\"') {
			msg = &msg[1];
			int len = strlen(msg)-1;
			if (msg[len]=='\"')
				msg[len] = '\0';
		}
		player_t *pPlayer;
		char* say_this_msg = UTIL_FillWithVars(msg);
		for (int i = 1; i <= gpGlobals->maxClients;++i)	{
			pPlayer = GET_PLAYER_POINTER_I(i);
			if(pPlayer->valid&&pPlayer->stats_enabled&&CallsMe(pPlayer,"*"))
				UTIL_HudMessage(hudtextparm, say_this_msg, pPlayer->pEdict);
		}
	}
	else{
		SERVER_PRINT("Usage:  sm_say < message >\n");
	}
}

void CmdTell(void)
{
	if (CMD_ARGC() > 2){
		float x=-1.0,y=0.25,fxTime=0.5,holdTime=12.0,fadeinTime=0.02,fadeoutTime=2.0;
		int effect=1, channel = 1, r=200,g=100,b=0;
		//if faild it will be "200=100=0=-1=0.20=0=0.5=12=0.02=2.0=1"
		sscanf (sm_sayformat->string,"%d%*1s%d%*1s%d%*1s%f%*1s%f%*1s%d%*1s%f%*1s%f%*1s%f%*1s%f%*1s%d",
			&r,&g,&b,&x,&y,&effect,&fxTime,&holdTime,&fadeinTime,&fadeoutTime, &channel);
		hudtextparms_t hudtextparm;hudtextparm.a1 = 0;hudtextparm.a2 = 0;
		hudtextparm.r2 = 255;hudtextparm.g2 = 255;hudtextparm.b2 = 250;
		hudtextparm.r1 = r;hudtextparm.g1 = g;hudtextparm.b1 = b;
		hudtextparm.effect = effect;hudtextparm.holdTime = holdTime;
		hudtextparm.fadeoutTime = fadeoutTime;hudtextparm.fadeinTime = fadeinTime;
		hudtextparm.x = x;hudtextparm.y = y;
		hudtextparm.fxTime = fxTime;hudtextparm.channel = channel;
		char* msg = (char*)CMD_ARGV(2);
		int dest_type = 0;
		if (CMD_ARGC() > 3){
			dest_type = atoi(CMD_ARGV(3));
			if (dest_type < 1 || dest_type > 4)
				dest_type = 0;
		}
		player_t *pPlayer;
		char* say_this_msg = UTIL_FillWithVars(msg);
		for (int i = 1; i <= gpGlobals->maxClients;++i)	{
			pPlayer = GET_PLAYER_POINTER_I(i);
			if(pPlayer->valid&&pPlayer->stats_enabled&&CallsMe(pPlayer,CMD_ARGV(1)))	{
				if (dest_type)	
					UTIL_ClientPrint(pPlayer->pEdict,dest_type,say_this_msg);
				else
					UTIL_HudMessage(hudtextparm, say_this_msg , pPlayer->pEdict);
					
			}
		}
	}
	else{
		SERVER_PRINT("Usage:  sm_tell < * | #userid | wonid > < message > < 0 | 1 | 2 | 3 | 4 >\n");
	}
}

void CmdClExec(void)
{
	if (CMD_ARGC() > 2) {
		player_t *pPlayer;
		for (int i = 1; i <= gpGlobals->maxClients;++i)	{
			pPlayer = GET_PLAYER_POINTER_I(i);
			if(pPlayer->valid&&pPlayer->stats_enabled&&CallsMe(pPlayer,CMD_ARGV(1))) {				
				CLIENT_COMMAND(pPlayer->pEdict,UTIL_FillWithVars((char*)CMD_ARGV(2)));
			}
		}
	}
	else{
		SERVER_PRINT("Usage:  sm_clexec < * | #userid | wonid > < command >\n");
	}
}

void CmdShowMenu(void)
{
	if (CMD_ARGC() > 2) {
		player_t *pPlayer;
		for (int i = 1; i <= gpGlobals->maxClients;++i)	{
			pPlayer = GET_PLAYER_POINTER_I(i);
			if(pPlayer->valid&&pPlayer->stats_enabled&&CallsMe(pPlayer,CMD_ARGV(1))) {
				UTIL_ServerShowMenu( pPlayer, UTIL_FillWithVars((char*)CMD_ARGV(2)), CMD_ARGV(3),atoi(CMD_ARGV(4)),(CMD_ARGC()>5)?atof(CMD_ARGV(5)):-1 );
				if (sm_logmenuaction->value)
				UTIL_LogPrintf("\"%s<%i><%u><%s>\" triggered \"show_menu\" (menu \"%d\")\n",
					STRING( pPlayer->pEdict->v.netname ), 	
					GETPLAYERUSERID( pPlayer->pEdict ),
					GETPLAYERWONID( pPlayer->pEdict ),	
					pPlayer->team_name,pPlayer->menu_id);		
			}
		}
	}
	else{
		SERVER_PRINT("Usage:  sm_showmenu < * | #userid | wonid > < menu > < keys > < menuid > [ time in sec. ]\n");
	}
}

void UTIL_IntToString(int value, char *output)
{
	static const char words[28][12] = {"zero","one ","two ","three ","four ",
		"five ", "six ","seven ","eight ","nine ","ten ", //10
		"eleven ","twelve ","thirteen ","fourteen ","fifteen ",
		"sixteen ","seventeen ","eighteen ","nineteen ", //19
		"twenty ","thirty ","fourty ", "fifty ","sixty ",
		"seventy ","eighty ","ninety "}; //27

	int ten = value / 10;
	int	unit = value % 10;

	output[0]=0;

	if ( ten )	strcpy(output, words[ ( ten > 1 ) ? ( ten + 18 ) : ( unit + 10 ) ] );
	if ( ten != 1 && ( unit || !value ) ) strcat(output, words[ unit ] );
}

void CmdMotd(void) 
{
	if (CMD_ARGC() > 1) {
		motd_t*new_one=new motd_t;
		new_one->msg = new char[strlen(CMD_ARGS())+7];
		sprintf(new_one->msg,"echo %s\n",CMD_ARGS());
		new_one->next = NULL;
		if (sm_motd){
			motd_t*start = sm_motd;
			while (start->next)
				start = start->next;
			start->next = new_one;
		}
		else {
			sm_motd = new_one;
		}
	}
	else {
		SERVER_PRINT("Usage:  sm_motd < string >\n");
		if (sm_motd){
			SERVER_PRINT("Current motd:\n");
			for(motd_t*p = sm_motd; p ; p = p->next){
				SERVER_PRINT(p->msg);
			}
		}
		else {
			SERVER_PRINT("Current motd is empty.\n");
		}
	}
}

player_t * GetBestPlayer(int option, const char* team )
{
	player_t *pBest = NULL;

	int value1 = 0, value2 = 0, check1, check2;

	for (int a = 1; a <= gpGlobals->maxClients ; ++a)
	{
		player_t *pPlayer = GET_PLAYER_POINTER_I(a);

		if (!pPlayer->ingame || (team ? strcmpi(pPlayer->team_name,team) : false )) continue;

		if (option > 3)	{
			switch (option){
			case 4: //best killer
				check1 = pPlayer->gamestats.kills;
				check2 = pPlayer->gamestats.hs;
				break;
			case 5: //most disruptive
				check1 = pPlayer->gamestats.damage;
				check2 = pPlayer->gamestats.hits;
				break;
			case 6: //most accurate shots
				check1 = pPlayer->gamestats.hitgroup[HITGROUP_HEAD];
				check2 = pPlayer->gamestats.hitgroup[HITGROUP_STOMACH] + pPlayer->gamestats.hitgroup[HITGROUP_CHEST];
				break;
			}
		}
		else {
			switch (option){
			case 1: //best killer
				check1 = pPlayer->roundstats.kills;
				check2 = pPlayer->roundstats.hs;
				break;
			case 2: //most disruptive
				check1 = pPlayer->roundstats.damage;
				check2 = pPlayer->roundstats.hits;
				break;
			case 3: //most accurate shots
				check1 = pPlayer->roundstats.hitgroup[HITGROUP_HEAD];
				check2 = pPlayer->roundstats.hitgroup[HITGROUP_STOMACH] + pPlayer->roundstats.hitgroup[HITGROUP_CHEST];
				break;
			}
		}

		//go through all score and find out who is the best
		if ( value1 < check1 || ( value1 == check1 && value2 < check2) )
		{	
			value1 = check1;
			value2 = check2;
			pBest = pPlayer;
		}		
	}

	return pBest;
}

#define MAX_CVAR_LEN 64 // cvar len of name or value to get
#define MAX_BUF_LEN	256 //max. buffor for asked value
#define MAX_DATA_LEN 2048

const char* GetStatsValue(stat_t* stats, const char* src)
{
	static char value[2][MAX_BUF_LEN];
	static int i = 0; i = i ? 0 : 1;

	if (!stats) {
		*value[i]=0;
	}
	else if (!strcmp(src,"name")){
		if (stats->name)
			sprintf(value[i], "%s", stats->name);
		else
			*value[i]=0;
	}
	else if (!strcmp(src,"kills")){
		sprintf(value[i], "%d", stats->kills);
	}
	else if (!strcmp(src,"deaths")){
		sprintf(value[i], "%d", stats->deaths);
	}
	else if (!strcmp(src,"damage")){
		sprintf(value[i], "%d", stats->damage);
	}
	else if (!strcmp(src,"shots")){
		sprintf(value[i], "%d", stats->shots);
	}
	else if (!strcmp(src,"hits")){
		sprintf(value[i], "%d", stats->hits);
	}
	else if (!strcmp(src,"tks")){
		sprintf(value[i], "%d", stats->tks);
	}
	else if (!strcmp(src,"hs")){
		sprintf(value[i], "%d", stats->hs);
	}
	else if (!strcmp(src,"clip")){
		sprintf(value[i], "%d", stats->clip);
	}
	else if (!strcmp(src,"ammo")){
		sprintf(value[i], "%d", stats->ammo);
	}
	else if (!strcmp(src,"score")){
		sprintf(value[i], "%d", stats->score);
	}
	else if (!strcmp(src,"head")){
		sprintf(value[i], "%d", stats->hitgroup[HITGROUP_HEAD] );
	}
	else if (!strcmp(src,"chest")){
		sprintf(value[i], "%d", stats->hitgroup[HITGROUP_CHEST] );
	}
	else if (!strcmp(src,"stomach")){
		sprintf(value[i], "%d", stats->hitgroup[HITGROUP_STOMACH] );
	}
	else if (!strcmp(src,"leftarm")){
		sprintf(value[i], "%d", stats->hitgroup[HITGROUP_LEFTARM] );
	}
	else if (!strcmp(src,"rightarm")){
		sprintf(value[i], "%d", stats->hitgroup[HITGROUP_RIGHTARM] );
	}
	else if (!strcmp(src,"leftleg")){
		sprintf(value[i], "%d", stats->hitgroup[HITGROUP_LEFTLEG] );
	}
	else if (!strcmp(src,"rightleg")){
		sprintf(value[i], "%d", stats->hitgroup[HITGROUP_RIGHTLEG] );
	}
	else if (!strcmp(src,"acc")){
		float acc = ACCURACY_FORMULA( stats->shots, stats->hits );
		sprintf(value[i], "%.2f", acc );
	}
	else if (!strcmp(src,"eff")){
		float eff = EFFEC_FORMULA( stats->kills, stats->deaths );
		sprintf(value[i], "%.2f", eff );
	}
	else if (!strncmp(src,"mkill.",6)){

		if (!score.best || (score.best_type != stats->switcher + 1) ){
			score.best = GetBestPlayer(stats->switcher + 1, stats->name );
			score.best_type = stats->switcher + 1;
		}

		return GetPlayerValue( score.best , &src[6] );
	}
	else if (!strncmp(src,"mdisr.",6)){

		if (!score.best || (score.best_type != stats->switcher + 2) ) {
			score.best = GetBestPlayer(stats->switcher + 2, stats->name );
			score.best_type = stats->switcher + 2;
		}

		return GetPlayerValue( score.best , &src[6] );
	}
	else if (!strncmp(src,"macc.",5)){

		if (!score.best ||  (score.best_type != stats->switcher + 3) ){
			score.best = GetBestPlayer(stats->switcher + 3, stats->name );
			score.best_type = stats->switcher + 3;
		}

		return GetPlayerValue( score.best , &src[5] );
	}
	else {
		*value[i]=0;
	}

	return value[i];
}

const char* GetPlayerValue(player_t *pPlayer, const char* src)
{
	static char value[2][MAX_BUF_LEN];
	static int i = 0; i = i ? 0 : 1;

	if (!pPlayer) {
		*value[i]=0;
	}
	else if (!strcmp(src,"name")) // most frequantly used
	{
		return INFOKEY_VALUE(GET_INFOKEYBUFFER(pPlayer->pEdict),"name");
	}
	else if (!strncmp(src,"rd.",3)){ // stats for current round
		return GetStatsValue( &pPlayer->roundstats, &src[3] );
	}
	else if (!strncmp(src,"gm.",3)){ // stats from all play on current map
		return GetStatsValue( &pPlayer->gamestats, &src[3] );
	}
	else if (!strncmp(src,"tm.rd.",6)){ // team score
		return GetStatsValue( &score.roundstats[pPlayer->team_index], &src[6] );
	}
	else if (!strncmp(src,"tm.gm.",6)){ // team score
		return GetStatsValue( &score.gamestats[pPlayer->team_index], &src[6] );
	}
	else if (!strncmp(src,"k.",2)){ // killer
		return GetPlayerValue( pPlayer->killer, &src[2] );
	}
	else if (!strncmp(src,"v.",2)){ // victim
		return GetPlayerValue( pPlayer->victim, &src[2] );
	}
	else if (!strncmp(src,"w.",2)){ // currently used weapon
		return GetStatsValue( pPlayer->weapon, &src[2] );
	}
	else if (src[0] == 'w' && (src[2] == '.' || src[3] == '.')){ // custom wepon stats
		int index = (src[2] == '.') ? (src[1] - '0') : ( ((src[1] - '0')*10) + (src[2] - '0') );    
		return GetStatsValue( &pPlayer->wpnstats[index], &src[ (src[2] == '.') ? 3 : 4 ] );
	}
	else if (src[0] == 'a' && (src[2] == '.' || src[3] == '.')){ // specified stats from action with players
		int index = (src[2] == '.') ? (src[1] - '0') : ( ((src[1] - '0')*10) + (src[2] - '0') );    
		return GetStatsValue( &pPlayer->specstats[index], &src[ (src[2] == '.') ? 3 : 4 ] );
	}
	else if (!strncmp(src,"st.",3)){ // custom stats - diffrent on each event
		return GetStatsValue( pPlayer->custom_stats, &src[3] );
	}
	else if (!strcmp(src,"victims")){
		return GetFightList(pPlayer, false);
	}
	else if (!strcmp(src,"attackers")){
		return GetFightList(pPlayer, true);
	}
	else if (!strcmp(src,"health")){
		sprintf(value[i], "%d", pPlayer->health );
	}
	else if (!strcmp(src,"armor")){
		sprintf(value[i], "%d", pPlayer->armor );
	}
	else if (!strcmp(src,"money")){
		sprintf(value[i], "%d", pPlayer->money );
	}
	else if (!strcmp(src, "ping")) {
	    sprintf(value[i], "%d", (int)(pPlayer->latency_sum / (pPlayer->latency_samples ? pPlayer->latency_samples : 1 )) );
	}
	else if (!strcmp(src, "time")) {
		int time = gpGlobals->time - pPlayer->play_time;
	    sprintf(value[i], "%d:%02d", (int)(time / 60), (int)(time % 60)  );
	}
	else if (!strcmp(src,"wonid")){
		sprintf(value[i], "%u", GETPLAYERWONID(pPlayer->pEdict) );
	}
	else if (!strcmp(src,"userid")){
		sprintf(value[i], "%d", GETPLAYERUSERID(pPlayer->pEdict) );
	}
	else if (!strcmp(src,"ip")){
		return pPlayer->ip;
	}
	else if (!strcmp(src,"id")){
		sprintf(value[i], "%d", pPlayer->index );
	}
	else if (!strncmp(src,"@.",2)){
		return ENTITY_KEYVALUE(pPlayer->pEdict,(char*)(src+2));
	}
	else {
		*value[i]=0;
	}

	return value[i];
}

int GetPlayersNum()
{
	int num = 0;
	for(int a = 1; a <= gpGlobals->maxClients; ++a)	
		if (players[a].ingame) 
			++num;
	return num;
}

const char* GetGameValue(const char* src)
{
	static char value[2][MAX_BUF_LEN];
	static int i = 0; i = i ? 0 : 1;

	if (!strncmp(src,"v.",2)){
		return GetPlayerValue( score.victim, &src[2] );
	}
	else if (!strncmp(src,"k.",2)){
		return GetPlayerValue( score.killer, &src[2] );
	}
	else if (!strncmp(src,"b.",2)){
		return GetPlayerValue( score.bomber, &src[2] );
	}
	else if (!strncmp(src,"d.",2)){
		return GetPlayerValue( score.defuser, &src[2] );
	}
	else if (!strncmp(src,"p.",2)){
		return GetPlayerValue( score.player, &src[2] );
	}
	else if (src[0] == 'p' && (src[2] == '.' || src[3] == '.')){
		int index = (src[2] == '.') ? (src[1] - '0') : ( ((src[1] - '0')*10) + (src[2] - '0') );    
		return GetPlayerValue( GET_PLAYER_POINTER_I(index) , &src[ (src[2] == '.') ? 3 : 4 ] );
	}
	else if (!strncmp(src,"gm.",3)){
		return GetStatsValue( &score.gamestats[3] , &src[3] );
	}
	else if (!strncmp(src,"rd.",3)){
		return GetStatsValue( &score.roundstats[3] , &src[3] );
	}
	else if (!strncmp(src,"t1.gm.",6)){
		return GetStatsValue( &score.gamestats[1] , &src[6] );
	}
	else if (!strncmp(src,"t2.gm.",6)){
		return GetStatsValue( &score.gamestats[2] , &src[6] );
	}
	else if (!strncmp(src,"t1.rd.",6)){
		return GetStatsValue( &score.roundstats[1] , &src[6] );
	}
	else if (!strncmp(src,"t2.rd.",6)){
		return GetStatsValue( &score.roundstats[2] , &src[6] );
	}
	else if (!strcmp(src,"c4num")){
		sprintf(value[i], "%d", score.c4_timer );
	}
	else if (!strcmp(src,"c4str")){
		UTIL_IntToString(score.c4_timer, value[i]);
	}
	else if (!strcmp(src,"sm_mode")){
		sprintf(value[i], "%d", score.sm_mode );
	}
	else if (!strcmp(src,"maxplayers")){
		sprintf(value[i], "%d", gpGlobals->maxClients );
	}
	else if (!strcmp(src,"currentmap")){
		sprintf(value[i], "%s", STRING(gpGlobals->mapname) );
	}
	else if (!strcmp(src,"timeleft")){
		if (!mp_timelimit->value) return "0";
		int rem = (score.game_timeleft + mp_timelimit->value * 60) - gpGlobals->time;
		sprintf(value[i], "%d:%02d", (rem / 60),(rem % 60) );
	}
	else if (!strcmp(src,"thetime")){
		time_t td;	time(&td);
		strftime(value[i],sizeof(value),"%m/%d/%Y - %H:%M:%S",localtime(&td));
	}
	else if (!strcmp(src,"weekday")){
		time_t td;	time(&td);
		strftime(value[i],sizeof(value[0]),"%A",localtime(&td));
	}
	else if (!strcmp(src,"month")){
		time_t td;	time(&td);
		strftime(value[i],sizeof(value[0]),"%B",localtime(&td));
	}
	else if (!strcmp(src,"day")){
		time_t td;	time(&td);
		strftime(value[i],sizeof(value[0]),"%d",localtime(&td));
	}
	else if (!strcmp(src,"year")){
		time_t td;	time(&td);
		strftime(value[i],sizeof(value[0]),"%Y",localtime(&td));
	}
	else if (!strcmp(src,"gametime")){
		sprintf(value[i], "%.4f", gpGlobals->time );
	}
	else if (!strncmp(src,"@.",2)){
		return LOCALINFO((char*)(src+2));
	}
	else if (!strncmp(src,"#.",2)){
		sprintf(value[i], "%s", CVAR_GET_STRING(src + 2) );
	}
	else if (!strcmp(src,"playersnum")){
		sprintf(value[i], "%d", GetPlayersNum() );
	}
	else
	{
		return src;
	}

	return value[i];
}

#define MAX_LEVELS 5

const char* CheckCondition(const char* ask, const char* value, const char* yes, const char* no, int operation)
{
	const char* result = NULL;
	bool is_true = false;
	
	if ( IsANumber( ask ) )
	{
		float fValue = atof( ask );
		
		switch (operation)
		{
		case '?':
			is_true = ( fValue ) ? true : false;
			break;
		case '&':
			is_true = ( (int)fValue & atoi( value ) ) ? true : false;
			break;
		case '=':
			is_true = (fValue == atof( value )) ? true : false;
			break;
		case '<':
			is_true = (fValue < atof( value )) ? true : false;
			break;
		case '>':
			is_true = (fValue > atof( value )) ? true : false;
			break;
		case '!':
			is_true = (fValue != atof( value )) ? true : false;
			break;
		default:
			is_true = false;
		}
	}
	else if (operation) // not number but condition
	{ 
		switch (operation)
		{
		case '?':
			is_true = (*ask) ? true : false;
			break;
		case '&':
			is_true = (strstr(ask, value ))? true : false;
			break;
		case '=':
			is_true = (!strcmpi(ask, value ))? true : false;
			break;
		case '<':
			is_true = (strcmpi(ask, value ) < 0)? true : false;
			break;
		case '>':
			is_true = (strcmpi(ask, value ) > 0)? true : false;
			break;
		case '!':
			is_true = (strcmpi(ask, value )) ? true : false;
			break;
		default:
			is_true = false;
		}			
	}
	else
	{
		is_true = true;	
	}	
	
	if ( is_true )
	{
		result = ( strcmp( yes,"#skip!" ) ) ? yes : NULL;
	}
	else
	{
		result = ( strcmp( no,"#skip!" ) ) ? no : NULL;
	}

	return result;
}

const char* GetConditionedValue(const char* src, int* length)
{
	static char message[MAX_LEVELS][MAX_DATA_LEN];
	static int level = -1;

	if ( ++level == MAX_LEVELS )
	{
		message[level][ 0 ] = 0;
		return message[level--];
	}

	int len = 0; // length of expresion

	static char szName[MAX_LEVELS][MAX_CVAR_LEN]; 
	static char szValue[MAX_LEVELS][MAX_CVAR_LEN]; 
	static char szState1[MAX_LEVELS][MAX_BUF_LEN]; 
	static char szState2[MAX_LEVELS][MAX_BUF_LEN];

	szName[level][0] = 0;
	szValue[level][0] = 0;
	szState1[level][0] = 0;
	szState2[level][0] = 0;


	const char* begin = src;

	int iName = 0; //this is a name of value to get
	int iValue = 0; //this is an value to compate with requested value
	int iState1 = 0; //text on true
	int iState2 = 0; //text on false

	int operation = 0;

//first see what the expresion is ( maybe { x }  or  { x ? y : z }  )

	while ( *src ) 
	{
		if ( *src == '{' ) // { x ? y : z } - recurence
		{
			int cond_len = 0;

			const char* cond = GetConditionedValue(++src,&cond_len);

			while (*cond) // write from cond_reply to dest
			{
				szName[level][iName++] = *cond++;
			}

			src += cond_len;
			continue;
		}
		else if ( *src == '}' )
		{
			src++;
			break;
		}
		else if ( *src == '&' || *src == '<' || *src == '>' || *src == '=' || *src == '!' )
		{
			operation = *src++;

			while ( *src != '?' )
			{

				if ( *src == '{' ) // { x ? y : z } - recurence
				{
					int cond_len = 0;
					
					const char* cond = GetConditionedValue(++src,&cond_len);
					
					while (*cond) // write from cond_reply to dest
					{
						szValue[level][iValue++] = *cond++;
					}
					
					src += cond_len;
					continue;
				}

				szValue[level][iValue++] = *src++;
			}
		}

		if ( *src == '?' )
		{
			if ( !operation ) operation = *src;
			
			src++;

			while ( *src )
			{
				if ( *src == '{' ) // { x ? y : z } - recurence
				{
					int cond_len = 0;
					
					const char* cond = GetConditionedValue(++src,&cond_len);
					
					while (*cond) // write from cond_reply to dest
					{
						szState1[level][iState1++] = *cond++;
					}
					
					src += cond_len;
					continue;
				}
				else if ( *src == ':' && *(src - 1) != '\\' )
				{
					src++; //skip this ':'

					while ( *src )
					{				
						if ( *src == '{' ) // { x ? y : z } - recurence
						{
							int cond_len = 0;
							
							const char* cond = GetConditionedValue(++src,&cond_len);
							
							while (*cond) // write from cond_reply to dest
							{
								szState2[level][iState2++] = *cond++;
							}
							
							src += cond_len;
							continue;
						}

						if ( *src == '}' )
						{
							break;
						}
						
						szState2[level][iState2++] = *src++;	
					}
					
				}

				if ( *src == '}' )
				{
					break;
				}

				szState1[level][iState1++] = *src++;
			}

			src++;
			break;
		}
		
		szName[level][iName++] = *src++;
	}

	szName[level][iName] = 0;
	szValue[level][iValue] = 0;
	szState1[level][iState1] = 0;
	szState2[level][iState2] = 0;

	const char* askformore = GetGameValue(szName[level]);
	const char* value = (operation) ? CheckCondition(askformore,GetGameValue(szValue[level])
		,szState1[level],szState2[level],operation)	: askformore;

	if ( !value )
	{
		level--;
		return NULL;
	}

	while ( *value )
	{
		if ( *value == '\\' )
		{
			switch ( *(value+1) )
			{
			case '\\':
				message[level][len++] = *( value + 1 );
				message[level][len++] = *( (++value) + 1 );
				break;
			case 'n':
				message[level][len++] = '\n';
				break;
			case '\'':
				message[level][len++] = '\"';
				break;
			default:
				message[level][len++] = *(value+1);
			}
			value+=2;
			continue;
		}
		else if ( *value == '$' )
		{
			while (*askformore)
			{
				message[level][len++] = *askformore++;
			}	

			value++;
			continue;
		}		

		message[level][len++] = *value++;
	}

	message[ level ][ len ] = 0;

	*length = src - begin;

	return message[level--];
}

char* UTIL_FillWithVars(const char* src)
{
	static char message[MAX_LEVELS][MAX_DATA_LEN];
	static int level = -1;

	if ( ++level == MAX_LEVELS )
	{
		message[level][0] = 0;
		return message[level--];
	}

	int len = 0; //length of this message

	while (*src)
	{
		if ( *src == '{' ) // { x ? y : z }
		{
			int cond_len = 0;

			const char* cond = GetConditionedValue(++src,&cond_len);

			if (!cond )
			{
				message[level][0] = 0;
				return message[level--];
			}

			while (*cond) // write from cond_reply to dest
			{
				message[level][len++] = *cond++;
			}

			src += cond_len;
			continue;
		}
		else if ( *src == '\\' ) // \' x \'
		{
			switch ( *(src+1) )
			{
			case '\\':
				message[level][len++] = *( src + 1 );
				message[level][len++] = *( (++src) + 1 );
				break;
			case 'n':
				message[level][len++] = '\n';
				break;
			case '\'':
				message[level][len++] = '\"';
				break;
			default:
				message[level][len++] = *(src+1);
			}
			src+=2;
			continue;
		}

		// in other cases just write from src to dest

		message[level][len++] = *src++;
	}

	score.best = NULL;

	if ( len )
	{
		message[level][len++] = '\n';
	}

	message[level][len] = 0;
	return message[level--];
}

#define MAX_PRINT_MSG 190

void UTIL_ClientPrint( edict_t *pEntity, int msg_dest,  char *fmt, ... )
{	
	va_list			argptr;
	static char		msg_name[512];
	
	va_start ( argptr, fmt );
	vsprintf ( msg_name, fmt, argptr );
	va_end   ( argptr );

	MESSAGE_BEGIN( MSG_ONE, gmsgTextMsg, NULL, pEntity );
	WRITE_BYTE( msg_dest );

	static char message[MAX_PRINT_MSG+2];
	if ( strlen( msg_name ) < MAX_PRINT_MSG ) {
		strcpy( message, msg_name );
	}
	else {
		strncpy( message, msg_name, MAX_PRINT_MSG );
		message[MAX_PRINT_MSG] = 0;		// strncpy doesn't always append the null terminator
	}

	WRITE_STRING( message );
	MESSAGE_END();
}

void UTIL_ClientPrintMsgAll( int msg_dest,  char *fmt, ... )
{	
	va_list			argptr;
	static char		string[512];
	
	va_start ( argptr, fmt );
	vsprintf ( string, fmt, argptr );
	va_end   ( argptr );

	MESSAGE_BEGIN( MSG_ALL, gmsgTextMsg );
		WRITE_BYTE( msg_dest );

	char message[MAX_PRINT_MSG+2];
	if ( strlen( string ) < MAX_PRINT_MSG ) {
		strcpy( message, string );
	}
	else {
		strncpy( message, string, MAX_PRINT_MSG );
		message[MAX_PRINT_MSG] = 0;		// strncpy doesn't always append the null terminator
	}

		WRITE_STRING( message );
	MESSAGE_END();
}

#define MAX_MENU_CHUNK 176

void UTIL_ShowMenu( player_t *pPlayer, int slots, int displaytime, char *aMenuList )
{
	char chunk[MAX_MENU_CHUNK + 1];

	char *pMenuList = aMenuList;

	int len = 0;

	while ( pMenuList && *pMenuList ) 
	{
		if ( strlen( pMenuList ) < MAX_MENU_CHUNK )
		{
			strcpy( chunk, pMenuList );
		}
		else 
		{
			strncpy( chunk, pMenuList, MAX_MENU_CHUNK );
			chunk[MAX_MENU_CHUNK] = 0;
		}

		len += strlen( chunk );//Move text to next chunk

		pMenuList = aMenuList + len;

		MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer->pEdict );	
			WRITE_SHORT( slots );
			WRITE_CHAR( displaytime );
			WRITE_BYTE(*pMenuList ? TRUE : FALSE); //Need more menu?
			WRITE_STRING(chunk);
		MESSAGE_END();
	}
}

void StatsMeMenu(player_t *pPlayer, int state)
{
	if (state < 0){ //we have pressed exit
		pPlayer->menu_type = MENU_IDLE;
		return;
	}
	char textmenu[512]; int list_end, list_begin, pages_num = 0, pos_num = 0, index_key = 0, keys = 0;
	for(action_t*s=sm_menu;s;s=s->next) ++pos_num;
	pages_num = (pos_num / 8) + ((pos_num % 8)?1:0);
	int len =(score.mod_id == MOD_CSTRIKE) ? sprintf(textmenu, "\\yStatsMe Menu \\R%d/%d\n\\w\n", state + 1, pages_num) 
		: sprintf(textmenu, "StatsMe Menu %d/%d\n\n", state + 1, pages_num); //Print header
	pPlayer->menu_state = state; //set position in menu (which page)
	list_begin = (state*8); //get begin of list
	list_end = (pos_num > list_begin + 8) ? (list_begin + 8) : pos_num;
	action_t*a=sm_menu;
	for(int c = 0;c<list_begin;c++)
		a=a->next;
	for (int i=list_begin;i<list_end;++i) {
		if (a->cmd && a->cmd[0] == ' ' && !a->cmd[1]){
			len+=sprintf(&textmenu[len], (score.mod_id == MOD_CSTRIKE)?
				(char*)"\\d    %s\\w":(char*)"    %s", UTIL_FillWithVars(a->name) );
			++index_key;
		}
		else {
			len+=sprintf(&textmenu[len], (score.mod_id == MOD_CSTRIKE)?
				(char*)"\\w%d.  %s":(char*)"%d.  %s", index_key+1, UTIL_FillWithVars(a->name) );
			keys += (1<<index_key++); //Add proper key to menu keys
		}
		a = a->next;
	}
	if (list_end < pos_num){
		len+=sprintf(&textmenu[len],(score.mod_id == MOD_CSTRIKE)?
			(char*)"\n\\w9.  More...":(char*)"\n9.  More...");
		keys += (1<<8);
	}
	strcat(&textmenu[len], (score.mod_id == MOD_CSTRIKE)?((state)?("\n\\w0.  Back"):("\n\\w0.  Exit")):
			((state)?("\n0.  Back"):("\n0.  Exit")));
	keys+=(1<<9);
	UTIL_ShowMenu(pPlayer, keys, -1,textmenu);
	pPlayer->menu_type = STATSME_MENU;
	pPlayer->menu_keys = keys;
}

void StatsMenu(player_t *pPlayer, int state)
{
	if (state < 0){ //we have pressed exit
		pPlayer->menu_type = MENU_IDLE;
		return;
	}
	pPlayer->menu_pplnum = 0; //get players list
	for (int z=1;z<=gpGlobals->maxClients;++z){
		if (players[z].ingame){
			pPlayer->menu_list[pPlayer->menu_pplnum++] = &players[z];
		}
	}
	int list_end, list_begin, pages_num = 0, index_key = 0, keys = 0; char textmenu[512];
	pages_num = (pPlayer->menu_pplnum / 8) + ((pPlayer->menu_pplnum % 8)?1:0); //get number of all pages
	int len = (score.mod_id == MOD_CSTRIKE) ? sprintf(textmenu, "\\yStats Menu \\R%d/%d\n\\w\n", state + 1, pages_num) //Print header
		: sprintf(textmenu, "Stats Menu %d/%d\n\n", state + 1, pages_num);
	pPlayer->menu_state = state; //set position in menu (which page)
	list_begin = (state*8); //get begin of list
	//check if this is a last page or we are at the middle
	list_end = (pPlayer->menu_pplnum > list_begin + 8) ? (list_begin + 8) : pPlayer->menu_pplnum;
	for (int i=list_begin;i<list_end;++i) {
		len+=sprintf(&textmenu[len], "%d.  %s\n", index_key+1, STRING(pPlayer->menu_list[i]->pEdict->v.netname));
		keys += (1<<index_key++); //Add proper key to menu keys
	}
	if (list_end < pPlayer->menu_pplnum){
		len+=sprintf(&textmenu[len],"\n9.  More...");
		keys += (1<<8);
	}
	strcat(&textmenu[len], (state)?("\n0.  Back"):("\n0.  Exit"));
	keys+=(1<<9);
	UTIL_ShowMenu(pPlayer, keys, -1,textmenu);
	pPlayer->menu_type = STATS_MENU;
	pPlayer->menu_keys = keys;
}

void UTIL_ServerShowMenu( player_t *pPlayer, const char *sMenu, const char *slots , int menuid, int displaytime)
{
	static int char_keys[10] = {512,1,2,4,8,16,32,64,128,256};
	static char chunk[MAX_MENU_CHUNK+1];
	const char *pMenu = sMenu;
	int keys = 0;
	int len = 0;

	if (*slots == 'b') //when slots begings with 'b' then value is already generated (f.e. "b519")
	{
		keys = atoi(++slots);
	} 
	else //without - we must convert 1, 2, 3, 0 to 1, 2, 4, 512
	{
		while (*slots)
		{
			keys |= char_keys[ ( *slots++ - '0' ) ];
		}
	}

	while ( pMenu && *pMenu ) 
	{
		if ( strlen( pMenu ) < MAX_MENU_CHUNK )
		{
			strcpy( chunk, pMenu );
		}
		else 
		{
			strncpy( chunk, pMenu, MAX_MENU_CHUNK );
			chunk[MAX_MENU_CHUNK] = 0;
		}

		len += strlen( chunk );

		pMenu = sMenu + len;

		MESSAGE_BEGIN( MSG_ONE, gmsgShowMenu, NULL, pPlayer->pEdict );	
		WRITE_SHORT( keys );
		WRITE_CHAR( displaytime );
		WRITE_BYTE( *pMenu ? TRUE : FALSE );
		WRITE_STRING( chunk );
		MESSAGE_END();
	}

	pPlayer->menu_keys  = keys;
	pPlayer->menu_id	= menuid;
	pPlayer->menu_type	= MENU_STANDARD;
}